<?php

    lt_include( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    lt_include( PLOG_CLASS_PATH."plugins/subscribe/class/view/pluginsubscribeshowview.class.php" );
    lt_include( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    lt_include( PLOG_CLASS_PATH."class/config/config.class.php" );
    lt_include( PLOG_CLASS_PATH."plugins/subscribe/class/dao/codevalidator.class.php" );

    class PluginSubscribeConfirmAction extends BlogAction
    {
        function PluginSubscribeConfirmAction($actionInfo, $request){
            $this->BlogAction($actionInfo, $request);

            $this->registerFieldValidator("code", new CodeValidator());

            $view = new ErrorView($this->_blogInfo);
			$view->setErrorMessage($this->_locale->tr("subscribe_error_incorrect_confirmation_code"));
			$this->setValidationErrorView($view);
            return true;
        }

		function perform(){
			$blogSettings = $this->_blogInfo->getSettings();
            $enabled = $blogSettings->getValue("plugin_subscribe_enabled", false);
            if(!$enabled){
                $this->_view = new ErrorView($this->_blogInfo);
                $this->_view->setErrorMessage($this->_locale->tr("subscribe_disabled"));
                $this->setCommonData();
                return false;
            }                        

            $confirmation = $this->_request->getValue("code");

            if(!Subscriptions::confirmSubscription($confirmation)){
                $this->_view = new ErrorView($this->_blogInfo);
                $this->_view->setErrorMessage(
                    $this->_locale->tr("subscribe_error_confirming"));
                $this->setCommonData();
                return false;

            }

			$this->_view = new PluginSubscribeShowView($this->_blogInfo, false);
			$this->_view->setSuccessMessage(
                $this->_locale->tr("subscribe_subscription_saved_ok"));
			$this->setCommonData();
			
            return true;		
        }
    }
?>